#include<Servo.h>
#include <OneButton.h>
#include <SevSeg.h>
#include <NewPing.h>

SevSeg sevseg;
Servo myservo1;

const int triggerPin = 52;
const int echoPin = 50;


NewPing sonar(triggerPin, echoPin, 32);

const int meterPin1 = A0;
const int meterPin2 = A1;

const int pressurePin = A2;

OneButton button(4, true);

int ledPin1 = 11; 
int ledPin2 = 12; 
int ledPin3 = 13; 

int code1;
int code2;
int code3;

int countDown = 120;
unsigned long lastTick;

int pressedButton = 0;

int x = 0;

  float checkTimer1 = 0;
  float checkTimer2 = 0;

  float falseTimer1 = 0;
  float falseTimer2 = 0;

const float VCC = 4.98;
const float R_DIV = 3230.0;

long duration;
int distance;
float delayTimer = 0;

bool won = false;

void setup() {
  Serial.begin(9600);
  
  //timer
  byte numDigits = 4;  
  byte digitPins[] = {46, 40, 38, 25};
  byte segmentPins[] = {44, 36, 29, 33, 35, 42, 27};
  bool resistorsOnSegments = 8;    
  sevseg.begin(COMMON_CATHODE, numDigits, digitPins, segmentPins, resistorsOnSegments);
  sevseg.setBrightness(90);

  //servo
  myservo1.attach(5);

  //button
  button.attachClick(SingleClick);

  button.attachLongPressStop(pressReset);

  //led
  pinMode(ledPin1, OUTPUT); // Declare the LED as an output
   pinMode(ledPin2, OUTPUT); // Declare the LED as an output
    pinMode(ledPin3, OUTPUT); // Declare the LED as an output

  //potmeter
  pinMode(meterPin1, INPUT);
  pinMode(meterPin2, INPUT);

  //sonar
  pinMode(triggerPin, OUTPUT);
  pinMode(echoPin, INPUT);

}

void loop() {
    Timer();
    Movement();
    Weight();
    WheelCodes();
    button.tick();

  //switch for the amount of led to turn on
  switch(x){
    case 0:
    digitalWrite(ledPin1, LOW);
    digitalWrite(ledPin2, LOW);
    digitalWrite(ledPin3, LOW);
    
    won = false;
    break;

    case 1:
    digitalWrite(ledPin1, HIGH);
    digitalWrite(ledPin2, LOW);
    digitalWrite(ledPin3, LOW);
    break;

    case 2:
    digitalWrite(ledPin1, HIGH);
    digitalWrite(ledPin2, HIGH);
    digitalWrite(ledPin3, LOW);
    break;

    case 3:
    digitalWrite(ledPin1, HIGH);
    digitalWrite(ledPin2, HIGH);
    digitalWrite(ledPin3, HIGH);
    won = true;
    break;
  }
}

void Timer(){
  unsigned long currentMillis = millis();

  //countdown
  if(currentMillis - lastTick >= 1000){
    countDown--;
    displayCountdownToSerial(); 
    lastTick += 1000;   
  } 

   //dont countdown below 0 
   if(countDown <= 0){
    myservo1.write(180);
    countDown = 0;
   }
  
    sevseg.setNumber(countDown, 0);
    sevseg.refreshDisplay();
}

void displayCountdownToSerial(){
  //couter in mm:ss
  int mins = countDown / 60;
  int secs = countDown % 60;
}

void SingleClick(){
  Serial.println("Cool 1");
  myservo1.write(0);

  countDown = 120;
  delayTimer = 0;
  
  x = 0;
  
  code1 = random(0, 168);
  code2 = random(0, 168);
  code3 = random(0,20);

  pressedButton = 0;
}

void pressReset(){
 //count amount of times pressed on the button
  Serial.println("Cool 2");
  pressedButton++;
  if(code3 == pressedButton){
    x++;
  }else if(pressedButton > code3){
      x--; 
      pressedButton = 0;
  }

}

void Weight(){
  int fsrADC = analogRead(pressurePin);
  
  if(fsrADC != 0){
    float fsrV = fsrADC * VCC / 1023.0; 

    float fsrR = R_DIV * (VCC / fsrV - 1.0);

    float force;
    float fsrG = 1.0 / fsrR; 
    if (fsrR <= 600){
      force = (fsrG - 0.00075) / 0.00000032639;
    }
    else{
      force =  fsrG / 0.000000642857;
    }
    //if not won == game over
    if(!won){
      if(force < 20){ 
        myservo1.write(180);
      }
    }
  }
}

void WheelCodes(){
  //potmeter right
  int randomCode1 = analogRead(meterPin1);
  randomCode1 = map(randomCode1, 0, 1007, 0, 251); /*0 to 168*/

  //potmeter left
  int randomCode2 = analogRead(meterPin2);
  randomCode2 = map(randomCode2, 0, 1007, 0, 251); /*0 to 168*/


  if(code1 == randomCode1){
    checkTimer1++;
    if(checkTimer1 == 2){
      x++; 
      falseTimer1 = 0;
    }
  }else{
    falseTimer1++;
    if(falseTimer1 == 2){
      x--; 
      checkTimer1 = 0;
    }
  }

  if(code2 == randomCode2){
    checkTimer2++;
    if(checkTimer2 == 2){
      x++; 
      falseTimer2 = 0;
    }
  }else{
    falseTimer2++;
    if(falseTimer2 == 2){
      x--; 
      checkTimer2 = 0;
    }
  }
}

void Movement(){
  digitalWrite(triggerPin, LOW);
  delayMicroseconds(2);

  digitalWrite(triggerPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(triggerPin, LOW);

  duration = pulseIn(echoPin, HIGH);
  distance = duration * 0.034/2;

 // distance = sonar.ping_cm();
 Serial.println(distance);
  if(distance >= 50){
    delayTimer += 0.005;
  }else{
    delayTimer = 0;
  }

  if(delayTimer > 5 && !won){
    myservo1.write(180); 
  }
}
